"{ Package: 'stx:libscm/common' }"

Object subclass:#SCMAbstractPackageModelRegistry
	instanceVariableNames:'manager repositories wcs packages'
	classVariableNames:''
	poolDictionaries:''
	category:'SCM-Common-StX'
!

SCMAbstractPackageModelRegistry class instanceVariableNames:'Current'

"
 No other class instance variables are inherited by this class.
"
!

!SCMAbstractPackageModelRegistry class methodsFor:'documentation'!

documentation
"
    A simple manager (registry) for package models

    [author:]
        Jan Vrany <jan.vrany@fit.cvut.cz>

    [instance variables:]

    [class variables:]

    [see also:]

"
! !

!SCMAbstractPackageModelRegistry class methodsFor:'instance creation'!

new
    "return an initialized instance"

    ^ self basicNew initialize.
! !

!SCMAbstractPackageModelRegistry class methodsFor:'accessing'!

current
    Current isNil ifTrue:[
        Current := self new
    ].
    ^Current

    "Created: / 06-10-2012 / 19:00:50 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

flush
    Current := nil.

    "Created: / 06-10-2012 / 21:52:10 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 03-12-2012 / 13:36:07 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

packageNamed: package
    ^self current packageNamed: package

    "Created: / 14-11-2012 / 00:14:55 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!SCMAbstractPackageModelRegistry methodsFor:'accessing'!

packageNamed:arg
    "raise an error: must be redefined in concrete subclass(es)"

    ^ self subclassResponsibility
! !

!SCMAbstractPackageModelRegistry methodsFor:'initialization'!

flush
    self initialize

    "Created: / 06-10-2012 / 21:51:37 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

flush: pattern
    "Flushes all cached data packages matching given name."

    self subclassResponsibility

    "Created: / 22-11-2012 / 11:37:59 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

initialize
    "Invoked when a new instance is created."

    "/ please change as required (and remove this comment)
    repositories := Dictionary new.
    wcs := Dictionary new.
    packages := Dictionary new.

    "/ super initialize.   -- commented since inherited method does nothing

    "Modified: / 06-10-2012 / 22:26:25 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!SCMAbstractPackageModelRegistry class methodsFor:'documentation'!

version_HG

    ^ '$Changeset: <not expanded> $'
!

version_SVN
    ^ 'Id::                                                                                                                        '
! !
