"{ Package: 'stx:libscm/mercurial' }"

Object subclass:#HGRepositoryObject
	instanceVariableNames:'repository'
	classVariableNames:''
	poolDictionaries:''
	category:'SCM-Mercurial-Internal'
!

!HGRepositoryObject class methodsFor:'documentation'!

documentation
"
    A base abstract superclass for Mercurial repository
    objects.

    [author:]
        Jan Vrany <jan.vrany@fit.cvut.cz>

    [instance variables:]

    [class variables:]

    [see also:]

"
! !

!HGRepositoryObject class methodsFor:'instance creation'!

new
    "return an initialized instance"

    ^ self basicNew initialize.
! !

!HGRepositoryObject methodsFor:'accessing'!

repository
    ^ repository
! !

!HGRepositoryObject methodsFor:'initialization'!

initialize
    "Invoked when a new instance is created."

    "/ please change as required (and remove this comment)
    "/ repository := nil.

    "/ super initialize.   -- commented since inherited method does nothing
!

setRepository: anHGRepository
    repository := anHGRepository

    "Created: / 17-10-2012 / 13:48:02 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!HGRepositoryObject methodsFor:'synchronized evaluation'!

synchronizationSemaphore
    ^repository synchronizationSemaphore

    "Created: / 16-12-2012 / 00:41:01 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

synchronizationSemaphore: aRecursionLock
    self breakPoint: #jv.
    repository synchronizationSemaphore: aRecursionLock

    "Created: / 16-12-2012 / 00:41:21 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!HGRepositoryObject class methodsFor:'documentation'!

version_HG

    ^ '$Changeset: <not expanded> $'
!

version_SVN
    ^ 'Id::                                                                                                                        '
! !
